#include "get_font_file.h"
#include <fontconfig/fontconfig.h>
#include <stddef.h>

static FcPattern *font_file = NULL;

const char *get_font_file (const char *font_name)
{
  FcConfig* config = FcInitLoadConfigAndFonts();
	//make pattern from font name
	FcPattern* pat = FcNameParse((const FcChar8*)"LiberationMono-Regular");
	FcConfigSubstitute(config, pat, FcMatchPattern);
	FcDefaultSubstitute(pat);
	char* fontFile = NULL;
	// find the font
	FcResult result;
	font_file = FcFontMatch(config, pat, &result);
	if (font_file)
	{
		FcChar8* file = NULL;
		if (FcPatternGetString(font_file, FC_FILE, 0, &file) == FcResultMatch)
		{
			//we found the font
			//This might be a fallback font
      fontFile = (char *) file;
		}
	}
	FcPatternDestroy(pat);
  FcConfigDestroy(config);
  return fontFile;
}

void free_font_file()
{
  if (font_file != NULL)
  {
    FcPatternDestroy(font_file);
  }
}
